<?php
/*
define("LED_RESET", "led_reset.txt");
define("LED_CLOCK", "led_clock.txt");
define("LED_DATA", 	"led_data.txt");
define("LED_ON", 	"led switch 1");
define("LED_OFF", 	"led switch 0");
define("LED_TIMEOUT", 200*1000); //in microseconds
*/

class RCDC_Controller {
	public $EngineA;
	public $EngineB;
	public $LogLevel = 2;

	function Send(){
		//Check engine values
		if($this->EngineA < -63) $this->EngineA = -63;
		if($this->EngineA > 63) $this->EngineA = 63;
		if($this->EngineB < -63) $this->EngineB = -63;
		if($this->EngineB > 63) $this->EngineB = 63;
		//Engine A
		if($this->EngineA == 0) $this->SendCommand(64);
		if($this->EngineA < 0) $this->SendCommand(64-abs($this->EngineA));
		if($this->EngineA > 0) $this->SendCommand(64+$this->EngineA);
		//Engine B
		if($this->EngineB == 0) $this->SendCommand(192);
		if($this->EngineB < 0) $this->SendCommand(192-abs($this->EngineB));
		if($this->EngineB > 0) $this->SendCommand(192+$this->EngineB);
	}
	
	function Stop(){
		$this->SendCommand(0);
	}
	
	function SendCommand($address){
		//Convert data
		$buffer = decbin($address);
		//Fill buffer
		for($i = strlen($buffer); $i < 8; $i++)
			$buffer = "0".$buffer;
		$this->Log("Address: $address", 1);
		$this->Log("Buffer: ".$buffer, 1);
		//Reset
		$this->LedReset(true);
		$this->LedReset(false);
		//Send data
		for($i = 0; $i < 8; $i++){
			if($buffer[$i] == 1)
				$this->LedData(true);
			else
				$this->LedData(false);
			//Clock
			$this->LedClock(true);
			$this->LedClock(false);
		}
	}
	
	function LedReset($state){
		if($state){
			file_put_contents(LED_RESET, LED_ON);
			$this->Log("LED RESET switched to ON", 2);
		} else {
			file_put_contents(LED_RESET, LED_OFF);
			$this->Log("LED RESET switched to OFF", 2);
		}
		usleep(LED_TIMEOUT);
	}
	
	function LedClock($state){
		if($state){
			file_put_contents(LED_CLOCK, LED_ON);
			$this->Log("LED CLOCK switched to ON", 2);
		} else {
			file_put_contents(LED_CLOCK, LED_OFF);
			$this->Log("LED CLOCK switched to OFF", 2);
		}
		usleep(LED_TIMEOUT);
	}
	
	function LedData($state){
		if($state){
			file_put_contents(LED_DATA, LED_ON);
			$this->Log("LED DATA switched to ON", 2);
		} else {
			file_put_contents(LED_DATA, LED_OFF);
			$this->Log("LED DATA switched to OFF", 2);
		}
		usleep(LED_TIMEOUT);
	}
	
	function Log($string, $level = 2){
		if($level <= $this->LogLevel)
			echo $string."\n";
	}
}
?>