#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define DATA_LED "/dev/gpio8"
#define CLOCK_LED "/dev/gpio11"
#define RESET_LED "/dev/gpio1"

#define CRR_A 0
#define CRR_B 0

int led_fd;

/*void usleep(unsigned long usec){
        timeval tv;
        tv.tv_sec = 0;
        tv.tv_usec = usec;
        select(0, NULL, NULL, NULL, &tv);
}*/

int DataBit(bool bitt){
	int f = open(DATA_LED, O_RDWR);
	if(bitt)
		write(f, "led switch 1", 12);
	else write(f, "led switch 0", 12);
	close(f);
	//usleep(100);
}

int ClockBit(bool bitt){
	int f = open(CLOCK_LED, O_RDWR);
	if(bitt)
		write(f, "led switch 1", 12);
	else write(f, "led switch 0", 12);
	close(f);
	//usleep(100);
}

int ResetBit(bool bitt){
	int f = open(RESET_LED, O_RDWR);
	if(bitt)
		write(f, "led switch 1", 12);
	else write(f, "led switch 0", 12);
	close(f);
	//usleep(100);
}

int SerialCommand(int i_byte){
        bool data[8];
        //Convert int to binary data
        int z  = i_byte;
        int d;
        for(int i = 0; i < 8; i++){
                switch(i){
                        case 0: d = 128; break;
                        case 1: d = 64; break;
                        case 2: d = 32; break;
                        case 3: d = 16; break;
                        case 4: d = 8; break;
                        case 5: d = 4; break;
                        case 6: d = 2; break;
                        case 7: d = 1; break;
                }
                //printf("[%d/%d]", z, d);
                if(z  / d > 0){
                        z = i_byte % d;
                        data[i] = true;
                        printf("1,", z);
                } else {
                        data[i] = false;
                        printf("0,", z);
                }
        }
        printf("\n");

		//Reset
		ResetBit(true);
		ResetBit(false);
		usleep(1000);
        //Send
        for(int i = 0; i < 8; i++){
                if(data[i] == false)
					DataBit(true);
                else
					DataBit(false);
			ClockBit(true);
			ClockBit(false);
			usleep(1000);
        }
}

int main(int argc,char *argv[]){
        //Send
		if(strcmp(argv[1], "stop") == 0){
			printf("Stopping...\n");
			SerialCommand(0);
		}
		else if(strcmp(argv[1], "forward") == 0){
			printf("Going forward...\n");
			SerialCommand(9 + CRR_A);
			SerialCommand(128 + CRR_B);
		}
		else if(strcmp(argv[1], "backward") == 0){
			printf("Going backward...\n");
			SerialCommand(127 + CRR_A);
			SerialCommand(255 + CRR_B);
		}
		else if(strcmp(argv[1], "left") == 0){
			printf("Turning left...\n");
			SerialCommand(1 + CRR_A);
			SerialCommand(192 + CRR_B);
		}
		else if(strcmp(argv[1], "right") == 0){
			printf("Turning right...\n");
			SerialCommand(64 + CRR_A);
			SerialCommand(128 + CRR_B);
		} else printf("Usage: ./rizeni [forward|stop|backward|left|right]\n");
		//printf("Delaying...\n");
		//usleep(1000000);
}
